package grizzly.http.client;

import java.util.HashMap;
import java.util.Map;

import com.sun.grizzly.CallbackHandler;
import com.sun.grizzly.Context;
import com.sun.grizzly.IOEvent;
import com.sun.grizzly.TCPConnectorHandler;
import com.sun.grizzly.Context.AttributeScope;
import com.sun.grizzly.util.AttributeHolder;

public class HttpCallback implements CallbackHandler<Context> {
	public static final String ATTIB_CONNECTION = "connection";
	private TCPConnectorHandler connectorHandler;

	public HttpCallback(TCPConnectorHandler ch) {
		connectorHandler = ch;
	}

	public void onConnect(IOEvent<Context> ioEvent) {
		Context ctx = ioEvent.attachment();
		try {
			connectorHandler.finishConnect(ctx.getSelectionKey());

			AttributeHolder ah = ctx
					.getAttributeHolderByScope(AttributeScope.CONNECTION);
			if (ah == null) {

				ctx.getSelectionKey().attach(new AttributeHolder() {
					private Map<String, Object> map = new HashMap<String, Object>(1);

					public Object getAttribute(String name) {
						return map.get(name);
					}

					public Map<String, Object> getAttributes() {
						return map;
					}

					public Object removeAttribute(String name) {
						return map.remove(name);
					}

					public void setAttribute(String name, Object value) {
						map.put(name, value);
					}

					public void setAttributes(Map<String, Object> attributes) {
						map = attributes;
					}
				});
			}
			ah = ctx.getAttributeHolderByScope(AttributeScope.CONNECTION);
			ah.setAttribute(ATTIB_CONNECTION, connectorHandler);

			ctx.getProtocolChain().execute(ctx);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void onRead(IOEvent<Context> ioEvent) {
		// TODO Auto-generated method stub

	}

	public void onWrite(IOEvent<Context> ioEvent) {
		// TODO Auto-generated method stub

	}
}
