package grizzly.http.client;

import java.io.IOException;
import java.net.InetSocketAddress;

import com.sun.grizzly.Controller;
import com.sun.grizzly.DefaultProtocolChain;
import com.sun.grizzly.DefaultProtocolChainInstanceHandler;
import com.sun.grizzly.ProtocolChain;
import com.sun.grizzly.ProtocolChainInstanceHandler;
import com.sun.grizzly.TCPConnectorHandler;
import com.sun.grizzly.TCPSelectorHandler;
import com.sun.grizzly.Controller.Protocol;
import com.sun.grizzly.utils.ControllerUtils;

public class HttpClient {

	private static final int SERVER_PORT = 8080;
	private static final String SERVER_HOST = "3cnl03748";
	private int port;
	private String host;
	private Controller controller;
	private ProtocolChainInstanceHandler instanceHandler = new DefaultProtocolChainInstanceHandler() {
		private ProtocolChain protocolChain;

		@Override
		public ProtocolChain poll() {
			if (protocolChain == null) {
				protocolChain = new DefaultProtocolChain();
				// protocolChain.addFilter(new HttpConnectFilter());
				protocolChain.addFilter(new HttpRequestFilter());
				protocolChain.addFilter(new HttpResponseParserFilter());
				protocolChain.addFilter(new HttpResponseFilter());
			}
			return protocolChain;
		}

	};

	public HttpClient(String serverHost, int serverPort) {
		host = serverHost;
		port = serverPort;
		initController();
	}

	protected void initController() {
		controller = new Controller();
		TCPSelectorHandler tcpSh = new TCPSelectorHandler(true);
		controller.setSelectorHandler(tcpSh);

		controller.setProtocolChainInstanceHandler(instanceHandler);
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		HttpClient hc = new HttpClient(SERVER_HOST, SERVER_PORT);
		hc.startCommunications();
	}

	public void startCommunications() throws IOException {
		ControllerUtils.startController(controller);

		TCPConnectorHandler ch = (TCPConnectorHandler) controller
				.acquireConnectorHandler(Protocol.TCP);
		ch.connect(new InetSocketAddress(host, port), new HttpCallback(ch));
	}

}
