package grizzly.http.client;

import java.nio.ByteBuffer;

import com.sun.grizzly.ProtocolParser;
import com.sun.grizzly.filter.ParserProtocolFilter;

public class HttpResponseParserFilter extends ParserProtocolFilter {
	public class HttpResponseParser implements ProtocolParser<ByteBuffer> {

		private ByteBuffer savedBuffer;

		public ByteBuffer getNextMessage() {
			return savedBuffer;
		}

		public boolean hasMoreBytesToParse() {
			return false;
		}

		public boolean hasNextMessage() {
			return savedBuffer == null ? false : true;
		}

		public boolean isExpectingMoreData() {
			return false;
		}

		public boolean releaseBuffer() {
			savedBuffer = null;
			return true;
		}

		public void startBuffer(ByteBuffer bb) {
			savedBuffer = bb;
		}

	}

	@Override
	public ProtocolParser<ByteBuffer> newProtocolParser() {
		return new HttpResponseParser();
	}

}
